% !TeX spellcheck = en_GB
The accuracy results for the filtered and unfiltered data in combination with each feature selection algorithm and model are shown in table \ref{tab:model_feature_results} and \ref{tab:model_feature_results_raw} with the best prediction for each model in bold.

\begin{table}[H]
	\caption{Accuracy results filtered data for each model and feature selection}
	\label{tab:model_feature_results}
	\begin{center}
		\begin{tabular}{l|l|l|l|l|l}
			& All   & VT    & LDA   & PCA   & RFECV \\ \hline
			SVC & 0.959 & 0.942  & \textbf{0.982} & 0.977 & 0.97 \\ \hline
			GBC & \textbf{0.977}  & 0.965 & 0.965 & 0.965 & 0.953 \\ \hline
			NB  & 0.959 & 0.907 & \textbf{0.971} & 0.93 & 0.953 \\ \hline
			LDA & \textbf{0.983} & 0.936 & \textbf{0.983} & 0.924 & 0.97 \\ 
		\end{tabular}
	\end{center}
\end{table}

\begin{table}[H]
	\caption{Accuracy results unfiltered data for each model and feature selection}
	\label{tab:model_feature_results_raw}
	\begin{center}
		\begin{tabular}{l|l|l|l|l|l}
			& All   & VT    & LDA   & PCA   & RFECV \\ \hline
			SVC & 0.965 & 0.942  & 0.953 & 0.959 & \textbf{0.97} \\ \hline
			GBC & 0.953  & 0.93 & 0.953 & 0.942 & \textbf{0.977} \\ \hline
			NB  & 0.953 & 0.872 & \textbf{0.977} & 0.924 & 0.959 \\ \hline
			LDA & \textbf{0.983} & 0.919 & \textbf{0.983} & 0.936 & 0.982 \\ 
		\end{tabular}
	\end{center}
\end{table}

Surprisingly the unfiltered data did just as good as the filtered data, with \gls{RFECV} and \gls{LDA} being the best feature selection algorithms and \gls{LDA} the best model.

For the filtered data all models did best with \gls{LDA} as feature selection but \gls{GBC}. This was somewhat unexpected, as \gls{SVC} and \gls{GBC} can handle a lot of features and noisy data very well and any type of feature selection should cause some information loss which should results in a worse accuracy.

While using all features has a very high accuracy it also requires the most computation for the model as it contains $129$ features, in contrast to $37$ features using \gls{VT}, $5$ features using \gls{LDA}, $10$ features using \gls{PCA} and $20$ features using \gls{RFECV}. Therefore using \gls{LDA} as feature selector seems to be the best decision for this dataset. Because the unfiltered and filtered data have the same accuracy, the filtering step could be skipped to save on computation.

Apart from the feature selection we can also compare the performance for each model. For this the best models from the filtered data with their respective feature selection algorithm from the above evaluation are selected and compared to the accuracy and fit time based on training size. The results are shown in figure \ref{img:line_chart_accuracy_fit_time_to_training_size_per_model}, with the train size increasing from $10\%$ to $100\%$ in $15\%.$ steps.
\begin{figure}[H]
	\centering
	\includegraphics[width=1\textwidth]{images/line_chart_accuracy_fit_time_to_training_size_per_model.png}
	\caption{Train size vs accuracy and fit time per model}
	\label{img:line_chart_accuracy_fit_time_to_training_size_per_model}
\end{figure}

The \gls{SVC} and \gls{NB} model have a nearly constant accuracy and fit time over different train sizes which can be attributed to the applied feature selection \gls{LDA} which leaks information to smaller training sizes. The other models improve in accuracy with a bigger train size with a decreasing improvement towards bigger train sizes. This is an indication that the model is not under fitted.\\
The fit time for each model shows some interesting variance (note the log scaling of the y-axis). \gls{SVC} and \gls{NB} are a order of magnitude faster then \gls{LDA}, making it a good choice when only low computational power is available. \gls{GBC}, being computationally expensive due to fitting $N-1$ trees, has by far the longest fit time of nearly three order of magnitudes higher then \gls{LDA}.

For a more in depth analysis of the actual classifications we can use the best performing model \gls{LDA} and take a look at the confusion matrix in table \ref{tab:conf_matrix_lda}.

\begin{table}[H]
	\caption{Confusion matrix for model LDA}
	\label{tab:conf_matrix_lda}
	\begin{center}
	\begin{tabular}{l|l|l|l|l|l|l}
		& W  & WU & WD & SI & ST & L  \\ \hline
		W  & 27 & 2  & 0  & 0  & 0  & 0  \\ \hline
		WU & 0  & 33 & 0  & 0  & 0  & 0  \\ \hline
		WD & 0  & 0  & 31 & 0  & 0  & 0  \\ \hline
		SI & 0  & 0  & 0  & 23 & 0  & 0  \\ \hline
		ST & 0  & 0  & 0  & 1  & 32 & 0  \\ \hline
		L  & 0  & 0  & 0  & 0  & 0  & 23 \\ 
	\end{tabular}
	\end{center}
\end{table}

Prediction mistakes were made between classes \textit{sitting} and \textit{standing} as well as \textit{walking upstairs} and \textit{walking}, which are very similar activities. If a higher accuracy would be required those wrong predictions could be further analysed and additional features could be generated to better separate between them. Alternatively, an additional step \textit{outlier removal} could be implemented in case those wrongly predicted data points are not representative to the respective class.




